#ifndef printer_window_h
#define printer_window_h

#include <gtk/gtk.h>
#include <Core/gb.h>
#include <stdint.h>

struct PrinterData {
	uint32_t *image;
	uint8_t height;
	uint8_t top_margin;
	uint8_t bottom_margin;
	uint8_t exposure;
};

#define PRINTER_WINDOW_TYPE (printer_window_get_type())
G_DECLARE_FINAL_TYPE(PrinterWindow, printer_window, SAMEBOY, PRINTER_WINDOW, GtkWindow)

PrinterWindow *printer_window_new(void);
void printer_window_clear(PrinterWindow *self);
bool printer_window_save(PrinterWindow *self);
void printer_window_update(PrinterWindow *self, struct PrinterData *data);
void printer_window_set_suggestion_prefix(PrinterWindow *self, char* prefix);

#endif
